package MyRedland::SubscriptionOrder;

use v5.34.1;

use strict;
use warnings;

use Moo;
use Types::Standard qw/Str Bool InstanceOf Int/;

has uuid => (
	is => 'ro',
	isa => Str,
);
has	product => (
	is => 'ro',
	isa => InstanceOf['MyRedland::Product'],
);
has user => (
	is => 'ro',
	isa => InstanceOf['MyRedland::Luser'],
);
has payment_intent_id => (
	is => 'ro',
	isa => Str,
);
has client_secret => (
	is => 'ro',
	isa => Str,
);

has renew_auto => (
	is => 'rw',
	isa => Bool,
);

has paid => (
	is => 'rw',
	isa => Bool,
);

has to_pay => (
	is => 'ro',
	isa => Int,
);

has create_date => (
	is => 'ro',
	isa => InstanceOf['DateTime'],
);

has save_card => (
	is => 'rw',
	isa => Bool,
);
1;
